#---------------------------------------------------------------------
# WCOM makefile.
# INSTRUCTIONS on how to make the program, using Microsoft compiler:
#  In the makefile, set the following controls:
#  Set M9=1, PROG32=1 to make the 32-bit version
#  Set M8=1 for the 16-bit version.
#  Set M8=1 for the 16-bit version.
#
#  For 16-bit windows, if you want to use more than the standard
#  9 com-ports, you can use the special RocketPort W3.1 driver
#  feature by un-commenting the define in the source for
#   "NEED_OVER_COM9".  Look at commrkt.h for more details.
#
#  Run nmake.
#
#  GUI development tools not supported, you are on your own.
#
#  Borland support has not been used for a while, so may require some
#  work(your on your own).

PROG32=1
#BC45=1
#M8=1
M9=1

#DEBUG = 1
PROG=TestMP2


!ifdef M9
#---------------- Microsoft V9, 32BIT
RCC = RC
#MAPSYM = MAPSYM
C_OP = -c -Z7 -Od -W3 -DWIN32 -D_WIN32
CC = cl
C_TARG = $*.c
CPP_TARG = $*.cpp
LIB_EXE = lib
ASM_EXE = tasm /ml /mx $*;
#LINK_OP = /NOD /RELEASE -align:0x1000
LINK_OP = -map:$(PROG).map
LINK_EXE = LINK
LIB_EXTRA =
LIB_EXTRA = gdi32.lib user32.lib
#LIB_EXTRA = kernal32 advapi user32 gdi32 comdlg32
OBJ_EXTRA =
! ifdef DEBUG
LINK_OP = $(LINK_OP) -debug:full -debugtype:cv
C_OP = $(C_OP) -Zi -Od
! endif
!endif

.c.obj     :
            $(CC) $(C_OP) $(C_TARG)

.cpp.obj     :
            $(CC) $(C_OP) $(CPP_TARG)

.asm.obj :
             $(ASM_EXE)

.exe.sym    :
            $(MAPSYM) $*.map

mods1 = $(PROG).obj
deps1 = $(PROG).lnk $(PROG).res

!ifdef MAPSYM
!ifdef DEBUG
$(PROG).sym : $(PROG).EXE
!endif
!endif

$(PROG).EXE: $(mods1) $(deps1)
          $(LINK_EXE) $(LINK_OP) @$(PROG).lnk

!ifdef M9
$(PROG).lnk: makefile
        echo -out:$(PROG).exe > $(PROG).lnk
        echo $(OBJ_EXTRA) $(mods1) >> $(PROG).lnk
        echo $(LIB_EXTRA) $(PROG).RES >> $(PROG).lnk
!endif

!ifdef BC45
$(PROG).lnk: makefile
        echo $(OBJ_EXTRA) $(mods1) > $(PROG).lnk
        echo $(PROG).exe  >> $(PROG).lnk
        echo $(PROG).map  >> $(PROG).lnk
        echo $(LIB_EXTRA) >> $(PROG).lnk
        echo $(PROG).def  >> $(PROG).lnk
        echo $(PROG).res; >> $(PROG).lnk
!endif

$(PROG).obj: $(PROG).cpp $(PROG).h $(PROG)r.h

$(PROG).res: $(PROG).rc $(PROG)r.h
   $(RCC) $(PROG).RC 


#  $(RCC) /l 0x412 /fo"$(INTDIR)\testmp2.res" $(PROG).RC
