/* wcom.h */

#define PKT_READ_SIZE 5000

void mess_line(char *str, int line_num);
void im_mess1(char *str1, int i1,
              char *str2, int i2);
void mess_num(int num);
void mess_str(char *str);
void mess_char(char c);
void mess1(char *str1, int i1,
           char *str2, int i2);

           // NT driver custom ioctl numbers
#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) )
#define METHOD_BUFFERED                 0
#define FILE_ANY_ACCESS                 0
#define FILE_DEVICE_SERIAL_PORT         0x0000001b
#define IOCTL_RCKT_LOOPBACK_ON \
      CTL_CODE(FILE_DEVICE_SERIAL_PORT, 0x805,METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_RCKT_LOOPBACK_OFF \
      CTL_CODE(FILE_DEVICE_SERIAL_PORT, 0x806,METHOD_BUFFERED,FILE_ANY_ACCESS)

#define IOCTL_RCKT_SET_TOGGLE_LOW \
      CTL_CODE(FILE_DEVICE_SERIAL_PORT, 0x807,METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_RCKT_CLEAR_TOGGLE_LOW \
      CTL_CODE(FILE_DEVICE_SERIAL_PORT, 0x808,METHOD_BUFFERED,FILE_ANY_ACCESS)

#define IOCTL_RESET_MODEM \
      CTL_CODE(FILE_DEVICE_SERIAL_PORT, 11,METHOD_BUFFERED,FILE_ANY_ACCESS)

#define IOCTL_OXSER_READ_LSR \
      CTL_CODE(FILE_DEVICE_SERIAL_PORT, 61,METHOD_BUFFERED,FILE_ANY_ACCESS)

// win95 escapecomm ioctl ids to set 485 toggle mode
#define RTSTOGGLE_ON 15654L
#define RTSTOGGLE_OFF 15655L


/* text window memory */
#define TROWS 35
#define TCOLS 80

typedef struct {
  int  out_cnt;
  int  in_cnt;
  WORD error_flags;
  WORD event_flags;
} PortStatus;

class WCom {
public:

  HWND hwnd;        // handle of our port window
  WCom *next_wcom;  // keep linked list of all port windows
  HFONT hfont;
  char com_name[20];  // COM#
#ifdef WIN32
  HANDLE com_id;      // com port handle
  DWORD events;
  DWORD event_mask;   // bit flags of notifications we want
#else
  int com_id;
  WORD events;
  WORD event_mask;   // bit flags of notifications we want
#endif
  int testing_flag;  // flag to stop main processing while testing

  int loop_supported;  // set if a port supports comtrol-loop id
  int num_buttons;     // number of buttons on window
  int ticks;
  unsigned int far *event_ptr;  // win16 event ptr from setcommeventmask
  int  ev_rec_cnt;   // win16,  rec-cnt notification amount
  int  ev_send_cnt;  // win16, send-cnt notification amount
  BYTE far *msr_cheat_ptr;  // win 16 "cheat" to get msr status.
  WORD msr_status;          // modem status reg(input pins)
  WORD mcr_status;          // modem control status(output pins)
  WORD old_msr_status;      // detect change in
  WORD old_mcr_status;
  unsigned char in_buf[PKT_READ_SIZE+2];
  char text_buf[TROWS+2][TCOLS+3];
  int screen_update_flag;  // need to update the screen.
  int display_cur_row;
  int cur_row;
  int cur_col;
  int scr_size_x;
  int scr_size_y;
  DWORD ms_starttime;
  int cur_x;  // screen mouse position, current
  int cur_y;
#ifdef WIN32
 // extra Win32 baggage for overlapped(asynchronous mode)
 int         EventPendingFlag;
 OVERLAPPED  osEvent;     // for asynchronous operation

 OVERLAPPED  osWrite;     // for asynchronous operation
 int         OutPendingFlag;
 int         OutTotal;

 OVERLAPPED  osRead;      // for asynchronous operation
 int         InPendingFlag;
 int         InTotal;
#endif

  DCB dcb;               // our device control block, port-options

#ifdef WIN32
  COMMTIMEOUTS timeouts;  // win32 timeouts
#endif
 COMSTAT cur_com_stat;  // last reading.
 COMSTAT old_com_stat;  // recall so we can show changes

  WCom();
  ~WCom();
  void WCom::loop_test(void);
  void WCom::clear_scr(void);
  void WCom::check_com_port(void);
  int WCom::CheckEvents32(void);
  int WCom::OpenPort(char *name);
  int WCom::PortIdentify(void);
  int WCom::WritePort(unsigned char *str, int cnt);
  int WCom::ReadPort(unsigned char *str, int want_cnt, int *got_cnt);
  int WCom::StatusPort(PortStatus *ps);
  void WCom::update_screen(int all_flag);
  void WCom::mess_line(char *str, int line_num);
  void WCom::mess_num(int num);
  void WCom::mess_str(char *str, int len=0);
  void WCom::print_comm_errors(unsigned int err);
  void WCom::print_modem_state(unsigned int modem_state);
  void WCom::print_events(unsigned int events);
  int WCom::LoopBack(int on);
};

extern char gtmparr[80];
extern HWND glob_hwnd;
extern HINSTANCE glob_hinst;      // current instance

extern WCom *head_wcom;

